test-lib: rename the LIBPCRE prerequisite to PCRE
[git.git] / t / test-lib.sh
blob6abf1d19189ea0a012b95302bcbb5967c04b4015
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
26 else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
39 ################################################################
40 # It appears that people try to run tests without building...
41 "$GIT_BUILD_DIR/git" >/dev/null
42 if test $? != 1
43 then
44 echo >&2 'error: you do not seem to have built git yet.'
45 exit 1
48 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
49 export PERL_PATH SHELL_PATH
51 # if --tee was passed, write the output not only to the terminal, but
52 # additionally to the file test-results/$BASENAME.out, too.
53 case "$GIT_TEST_TEE_STARTED, $* " in
54 done,*)
55 # do not redirect again
57 *' --tee '*|*' --va'*|*' --verbose-log '*)
58 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
59 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
61 # Make this filename available to the sub-process in case it is using
62 # --verbose-log.
63 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
64 export GIT_TEST_TEE_OUTPUT_FILE
66 # Truncate before calling "tee -a" to get rid of the results
67 # from any previous runs.
68 >"$GIT_TEST_TEE_OUTPUT_FILE"
70 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
71 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
72 test "$(cat "$BASE.exit")" = 0
73 exit
75 esac
77 # For repeatability, reset the environment to known value.
78 # TERM is sanitized below, after saving color control sequences.
79 LANG=C
80 LC_ALL=C
81 PAGER=cat
82 TZ=UTC
83 export LANG LC_ALL PAGER TZ
84 EDITOR=:
85 # A call to "unset" with no arguments causes at least Solaris 10
86 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
87 # deriving from the command substitution clustered with the other
88 # ones.
89 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
90 my @env = keys %ENV;
91 my $ok = join("|", qw(
92 TRACE
93 DEBUG
94 USE_LOOKUP
95 TEST
96 .*_TEST
97 PROVE
98 VALGRIND
99 UNZIP
100 PERF_
101 CURL_VERBOSE
102 TRACE_CURL
104 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
105 print join("\n", @vars);
107 unset XDG_CONFIG_HOME
108 unset GITPERLLIB
109 GIT_AUTHOR_EMAIL=author@example.com
110 GIT_AUTHOR_NAME='A U Thor'
111 GIT_COMMITTER_EMAIL=committer@example.com
112 GIT_COMMITTER_NAME='C O Mitter'
113 GIT_MERGE_VERBOSITY=5
114 GIT_MERGE_AUTOEDIT=no
115 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
116 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
117 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
118 export EDITOR
120 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
121 GIT_TRACE_BARE=1
122 export GIT_TRACE_BARE
124 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
125 then
126 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
127 export GIT_INDEX_VERSION
130 # Add libc MALLOC and MALLOC_PERTURB test
131 # only if we are not executing the test with valgrind
132 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
133 test -n "$TEST_NO_MALLOC_CHECK"
134 then
135 setup_malloc_check () {
136 : nothing
138 teardown_malloc_check () {
139 : nothing
141 else
142 setup_malloc_check () {
143 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
144 export MALLOC_CHECK_ MALLOC_PERTURB_
146 teardown_malloc_check () {
147 unset MALLOC_CHECK_ MALLOC_PERTURB_
151 : ${ASAN_OPTIONS=detect_leaks=0}
152 export ASAN_OPTIONS
154 # Protect ourselves from common misconfiguration to export
155 # CDPATH into the environment
156 unset CDPATH
158 unset GREP_OPTIONS
159 unset UNZIP
161 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
162 1|2|true)
163 GIT_TRACE=4
165 esac
167 # Convenience
169 # A regexp to match 5 and 40 hexdigits
170 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
171 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
173 # Zero SHA-1
174 _z40=0000000000000000000000000000000000000000
176 EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
177 EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
179 # Line feed
180 LF='
183 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
184 # when case-folding filenames
185 u200c=$(printf '\342\200\214')
187 export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
189 # Each test should start with something like this, after copyright notices:
191 # test_description='Description of this test...
192 # This test checks if command xyzzy does the right thing...
194 # . ./test-lib.sh
195 test "x$TERM" != "xdumb" && (
196 test -t 1 &&
197 tput bold >/dev/null 2>&1 &&
198 tput setaf 1 >/dev/null 2>&1 &&
199 tput sgr0 >/dev/null 2>&1
200 ) &&
201 color=t
203 while test "$#" -ne 0
205 case "$1" in
206 -d|--d|--de|--deb|--debu|--debug)
207 debug=t; shift ;;
208 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
209 immediate=t; shift ;;
210 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
211 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
213 shift; test "$#" -ne 0 || {
214 echo 'error: -r requires an argument' >&2;
215 exit 1;
217 run_list=$1; shift ;;
218 --run=*)
219 run_list=${1#--*=}; shift ;;
220 -h|--h|--he|--hel|--help)
221 help=t; shift ;;
222 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
223 verbose=t; shift ;;
224 --verbose-only=*)
225 verbose_only=${1#--*=}
226 shift ;;
227 -q|--q|--qu|--qui|--quie|--quiet)
228 # Ignore --quiet under a TAP::Harness. Saying how many tests
229 # passed without the ok/not ok details is always an error.
230 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
231 --with-dashes)
232 with_dashes=t; shift ;;
233 --no-color)
234 color=; shift ;;
235 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
236 valgrind=memcheck
237 shift ;;
238 --valgrind=*)
239 valgrind=${1#--*=}
240 shift ;;
241 --valgrind-only=*)
242 valgrind_only=${1#--*=}
243 shift ;;
244 --tee)
245 shift ;; # was handled already
246 --root=*)
247 root=${1#--*=}
248 shift ;;
249 --chain-lint)
250 GIT_TEST_CHAIN_LINT=1
251 shift ;;
252 --no-chain-lint)
253 GIT_TEST_CHAIN_LINT=0
254 shift ;;
256 trace=t
257 verbose=t
258 shift ;;
259 --verbose-log)
260 verbose_log=t
261 shift ;;
263 echo "error: unknown test option '$1'" >&2; exit 1 ;;
264 esac
265 done
267 if test -n "$valgrind_only"
268 then
269 test -z "$valgrind" && valgrind=memcheck
270 test -z "$verbose" && verbose_only="$valgrind_only"
271 elif test -n "$valgrind"
272 then
273 verbose=t
276 if test -n "$color"
277 then
278 # Save the color control sequences now rather than run tput
279 # each time say_color() is called. This is done for two
280 # reasons:
281 # * TERM will be changed to dumb
282 # * HOME will be changed to a temporary directory and tput
283 # might need to read ~/.terminfo from the original HOME
284 # directory to get the control sequences
285 # Note: This approach assumes the control sequences don't end
286 # in a newline for any terminal of interest (command
287 # substitutions strip trailing newlines). Given that most
288 # (all?) terminals in common use are related to ECMA-48, this
289 # shouldn't be a problem.
290 say_color_error=$(tput bold; tput setaf 1) # bold red
291 say_color_skip=$(tput setaf 4) # blue
292 say_color_warn=$(tput setaf 3) # brown/yellow
293 say_color_pass=$(tput setaf 2) # green
294 say_color_info=$(tput setaf 6) # cyan
295 say_color_reset=$(tput sgr0)
296 say_color_="" # no formatting for normal text
297 say_color () {
298 test -z "$1" && test -n "$quiet" && return
299 eval "say_color_color=\$say_color_$1"
300 shift
301 printf "%s\\n" "$say_color_color$*$say_color_reset"
303 else
304 say_color() {
305 test -z "$1" && test -n "$quiet" && return
306 shift
307 printf "%s\n" "$*"
311 TERM=dumb
312 export TERM
314 error () {
315 say_color error "error: $*"
316 GIT_EXIT_OK=t
317 exit 1
320 say () {
321 say_color info "$*"
324 if test -n "$HARNESS_ACTIVE"
325 then
326 if test "$verbose" = t || test -n "$verbose_only"
327 then
328 printf 'Bail out! %s\n' \
329 'verbose mode forbidden under TAP harness; try --verbose-log'
330 exit 1
334 test "${test_description}" != "" ||
335 error "Test script did not set test_description."
337 if test "$help" = "t"
338 then
339 printf '%s\n' "$test_description"
340 exit 0
343 exec 5>&1
344 exec 6<&0
345 exec 7>&2
346 if test "$verbose_log" = "t"
347 then
348 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
349 elif test "$verbose" = "t"
350 then
351 exec 4>&2 3>&1
352 else
353 exec 4>/dev/null 3>/dev/null
356 # Send any "-x" output directly to stderr to avoid polluting tests
357 # which capture stderr. We can do this unconditionally since it
358 # has no effect if tracing isn't turned on.
360 # Note that this sets up the trace fd as soon as we assign the variable, so it
361 # must come after the creation of descriptor 4 above. Likewise, we must never
362 # unset this, as it has the side effect of closing descriptor 4, which we
363 # use to show verbose tests to the user.
365 # Note also that we don't need or want to export it. The tracing is local to
366 # this shell, and we would not want to influence any shells we exec.
367 BASH_XTRACEFD=4
369 test_failure=0
370 test_count=0
371 test_fixed=0
372 test_broken=0
373 test_success=0
375 test_external_has_tap=0
377 die () {
378 code=$?
379 if test -n "$GIT_EXIT_OK"
380 then
381 exit $code
382 else
383 echo >&5 "FATAL: Unexpected exit with code $code"
384 exit 1
388 GIT_EXIT_OK=
389 trap 'die' EXIT
390 trap 'exit $?' INT
392 # The user-facing functions are loaded from a separate file so that
393 # test_perf subshells can have them too
394 . "$TEST_DIRECTORY/test-lib-functions.sh"
396 # You are not expected to call test_ok_ and test_failure_ directly, use
397 # the test_expect_* functions instead.
399 test_ok_ () {
400 test_success=$(($test_success + 1))
401 say_color "" "ok $test_count - $@"
404 test_failure_ () {
405 test_failure=$(($test_failure + 1))
406 say_color error "not ok $test_count - $1"
407 shift
408 printf '%s\n' "$*" | sed -e 's/^/# /'
409 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
412 test_known_broken_ok_ () {
413 test_fixed=$(($test_fixed+1))
414 say_color error "ok $test_count - $@ # TODO known breakage vanished"
417 test_known_broken_failure_ () {
418 test_broken=$(($test_broken+1))
419 say_color warn "not ok $test_count - $@ # TODO known breakage"
422 test_debug () {
423 test "$debug" = "" || eval "$1"
426 match_pattern_list () {
427 arg="$1"
428 shift
429 test -z "$*" && return 1
430 for pattern_
432 case "$arg" in
433 $pattern_)
434 return 0
435 esac
436 done
437 return 1
440 match_test_selector_list () {
441 title="$1"
442 shift
443 arg="$1"
444 shift
445 test -z "$1" && return 0
447 # Both commas and whitespace are accepted as separators.
448 OLDIFS=$IFS
449 IFS=' ,'
450 set -- $1
451 IFS=$OLDIFS
453 # If the first selector is negative we include by default.
454 include=
455 case "$1" in
456 !*) include=t ;;
457 esac
459 for selector
461 orig_selector=$selector
463 positive=t
464 case "$selector" in
466 positive=
467 selector=${selector##?}
469 esac
471 test -z "$selector" && continue
473 case "$selector" in
474 *-*)
475 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
476 then
477 echo "error: $title: invalid non-numeric in range" \
478 "start: '$orig_selector'" >&2
479 exit 1
481 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
482 then
483 echo "error: $title: invalid non-numeric in range" \
484 "end: '$orig_selector'" >&2
485 exit 1
489 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
490 then
491 echo "error: $title: invalid non-numeric in test" \
492 "selector: '$orig_selector'" >&2
493 exit 1
495 esac
497 # Short cut for "obvious" cases
498 test -z "$include" && test -z "$positive" && continue
499 test -n "$include" && test -n "$positive" && continue
501 case "$selector" in
503 if test $arg -le ${selector#-}
504 then
505 include=$positive
509 if test $arg -ge ${selector%-}
510 then
511 include=$positive
514 *-*)
515 if test ${selector%%-*} -le $arg \
516 && test $arg -le ${selector#*-}
517 then
518 include=$positive
522 if test $arg -eq $selector
523 then
524 include=$positive
527 esac
528 done
530 test -n "$include"
533 maybe_teardown_verbose () {
534 test -z "$verbose_only" && return
535 exec 4>/dev/null 3>/dev/null
536 verbose=
539 last_verbose=t
540 maybe_setup_verbose () {
541 test -z "$verbose_only" && return
542 if match_pattern_list $test_count $verbose_only
543 then
544 exec 4>&2 3>&1
545 # Emit a delimiting blank line when going from
546 # non-verbose to verbose. Within verbose mode the
547 # delimiter is printed by test_expect_*. The choice
548 # of the initial $last_verbose is such that before
549 # test 1, we do not print it.
550 test -z "$last_verbose" && echo >&3 ""
551 verbose=t
552 else
553 exec 4>/dev/null 3>/dev/null
554 verbose=
556 last_verbose=$verbose
559 maybe_teardown_valgrind () {
560 test -z "$GIT_VALGRIND" && return
561 GIT_VALGRIND_ENABLED=
564 maybe_setup_valgrind () {
565 test -z "$GIT_VALGRIND" && return
566 if test -z "$valgrind_only"
567 then
568 GIT_VALGRIND_ENABLED=t
569 return
571 GIT_VALGRIND_ENABLED=
572 if match_pattern_list $test_count $valgrind_only
573 then
574 GIT_VALGRIND_ENABLED=t
578 want_trace () {
579 test "$trace" = t && test "$verbose" = t
582 # This is a separate function because some tests use
583 # "return" to end a test_expect_success block early
584 # (and we want to make sure we run any cleanup like
585 # "set +x").
586 test_eval_inner_ () {
587 # Do not add anything extra (including LF) after '$*'
588 eval "
589 want_trace && set -x
593 test_eval_ () {
594 # We run this block with stderr redirected to avoid extra cruft
595 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
596 # the shell from printing the "set +x" to turn it off (nor the saving
597 # of $? before that). But we can make sure that the output goes to
598 # /dev/null.
600 # The test itself is run with stderr put back to &4 (so either to
601 # /dev/null, or to the original stderr if --verbose was used).
603 test_eval_inner_ "$@" </dev/null >&3 2>&4
604 test_eval_ret_=$?
605 if want_trace
606 then
607 set +x
608 if test "$test_eval_ret_" != 0
609 then
610 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
613 } 2>/dev/null
614 return $test_eval_ret_
617 test_run_ () {
618 test_cleanup=:
619 expecting_failure=$2
621 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
622 # turn off tracing for this test-eval, as it simply creates
623 # confusing noise in the "-x" output
624 trace_tmp=$trace
625 trace=
626 # 117 is magic because it is unlikely to match the exit
627 # code of other programs
628 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
629 then
630 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
632 trace=$trace_tmp
635 setup_malloc_check
636 test_eval_ "$1"
637 eval_ret=$?
638 teardown_malloc_check
640 if test -z "$immediate" || test $eval_ret = 0 ||
641 test -n "$expecting_failure" && test "$test_cleanup" != ":"
642 then
643 setup_malloc_check
644 test_eval_ "$test_cleanup"
645 teardown_malloc_check
647 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
648 then
649 echo ""
651 return "$eval_ret"
654 test_start_ () {
655 test_count=$(($test_count+1))
656 maybe_setup_verbose
657 maybe_setup_valgrind
660 test_finish_ () {
661 echo >&3 ""
662 maybe_teardown_valgrind
663 maybe_teardown_verbose
666 test_skip () {
667 to_skip=
668 skipped_reason=
669 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
670 then
671 to_skip=t
672 skipped_reason="GIT_SKIP_TESTS"
674 if test -z "$to_skip" && test -n "$test_prereq" &&
675 ! test_have_prereq "$test_prereq"
676 then
677 to_skip=t
679 of_prereq=
680 if test "$missing_prereq" != "$test_prereq"
681 then
682 of_prereq=" of $test_prereq"
684 skipped_reason="missing $missing_prereq${of_prereq}"
686 if test -z "$to_skip" && test -n "$run_list" &&
687 ! match_test_selector_list '--run' $test_count "$run_list"
688 then
689 to_skip=t
690 skipped_reason="--run"
693 case "$to_skip" in
695 say_color skip >&3 "skipping test: $@"
696 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
697 : true
700 false
702 esac
705 # stub; perf-lib overrides it
706 test_at_end_hook_ () {
710 test_done () {
711 GIT_EXIT_OK=t
713 if test -z "$HARNESS_ACTIVE"
714 then
715 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
716 mkdir -p "$test_results_dir"
717 base=${0##*/}
718 test_results_path="$test_results_dir/${base%.sh}.counts"
720 cat >"$test_results_path" <<-EOF
721 total $test_count
722 success $test_success
723 fixed $test_fixed
724 broken $test_broken
725 failed $test_failure
730 if test "$test_fixed" != 0
731 then
732 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
734 if test "$test_broken" != 0
735 then
736 say_color warn "# still have $test_broken known breakage(s)"
738 if test "$test_broken" != 0 || test "$test_fixed" != 0
739 then
740 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
741 msg="remaining $test_remaining test(s)"
742 else
743 test_remaining=$test_count
744 msg="$test_count test(s)"
746 case "$test_failure" in
748 # Maybe print SKIP message
749 if test -n "$skip_all" && test $test_count -gt 0
750 then
751 error "Can't use skip_all after running some tests"
753 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
755 if test $test_external_has_tap -eq 0
756 then
757 if test $test_remaining -gt 0
758 then
759 say_color pass "# passed all $msg"
761 say "1..$test_count$skip_all"
764 test -d "$remove_trash" &&
765 cd "$(dirname "$remove_trash")" &&
766 rm -rf "$(basename "$remove_trash")"
768 test_at_end_hook_
770 exit 0 ;;
773 if test $test_external_has_tap -eq 0
774 then
775 say_color error "# failed $test_failure among $msg"
776 say "1..$test_count"
779 exit 1 ;;
781 esac
784 if test -n "$valgrind"
785 then
786 make_symlink () {
787 test -h "$2" &&
788 test "$1" = "$(readlink "$2")" || {
789 # be super paranoid
790 if mkdir "$2".lock
791 then
792 rm -f "$2" &&
793 ln -s "$1" "$2" &&
794 rm -r "$2".lock
795 else
796 while test -d "$2".lock
798 say "Waiting for lock on $2."
799 sleep 1
800 done
805 make_valgrind_symlink () {
806 # handle only executables, unless they are shell libraries that
807 # need to be in the exec-path.
808 test -x "$1" ||
809 test "# " = "$(head -c 2 <"$1")" ||
810 return;
812 base=$(basename "$1")
813 case "$base" in
814 test-*)
815 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
818 symlink_target="$GIT_BUILD_DIR/$base"
820 esac
821 # do not override scripts
822 if test -x "$symlink_target" &&
823 test ! -d "$symlink_target" &&
824 test "#!" != "$(head -c 2 < "$symlink_target")"
825 then
826 symlink_target=../valgrind.sh
828 case "$base" in
829 *.sh|*.perl)
830 symlink_target=../unprocessed-script
831 esac
832 # create the link, or replace it if it is out of date
833 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
836 # override all git executables in TEST_DIRECTORY/..
837 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
838 mkdir -p "$GIT_VALGRIND"/bin
839 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
841 make_valgrind_symlink $file
842 done
843 # special-case the mergetools loadables
844 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
845 OLDIFS=$IFS
846 IFS=:
847 for path in $PATH
849 ls "$path"/git-* 2> /dev/null |
850 while read file
852 make_valgrind_symlink "$file"
853 done
854 done
855 IFS=$OLDIFS
856 PATH=$GIT_VALGRIND/bin:$PATH
857 GIT_EXEC_PATH=$GIT_VALGRIND/bin
858 export GIT_VALGRIND
859 GIT_VALGRIND_MODE="$valgrind"
860 export GIT_VALGRIND_MODE
861 GIT_VALGRIND_ENABLED=t
862 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
863 export GIT_VALGRIND_ENABLED
864 elif test -n "$GIT_TEST_INSTALLED"
865 then
866 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
867 error "Cannot run git from $GIT_TEST_INSTALLED."
868 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
869 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
870 else # normal case, use ../bin-wrappers only unless $with_dashes:
871 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
872 if ! test -x "$git_bin_dir/git"
873 then
874 if test -z "$with_dashes"
875 then
876 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
878 with_dashes=t
880 PATH="$git_bin_dir:$PATH"
881 GIT_EXEC_PATH=$GIT_BUILD_DIR
882 if test -n "$with_dashes"
883 then
884 PATH="$GIT_BUILD_DIR:$PATH"
887 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
888 GIT_CONFIG_NOSYSTEM=1
889 GIT_ATTR_NOSYSTEM=1
890 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
892 if test -z "$GIT_TEST_CMP"
893 then
894 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
895 then
896 GIT_TEST_CMP="$DIFF -c"
897 else
898 GIT_TEST_CMP="$DIFF -u"
902 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
903 export GITPERLLIB
904 test -d "$GIT_BUILD_DIR"/templates/blt || {
905 error "You haven't built things yet, have you?"
908 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
909 then
910 echo >&2 'You need to build test-chmtime:'
911 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
912 exit 1
915 # Test repository
916 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
917 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
918 case "$TRASH_DIRECTORY" in
919 /*) ;; # absolute path is good
920 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
921 esac
922 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
923 rm -fr "$TRASH_DIRECTORY" || {
924 GIT_EXIT_OK=t
925 echo >&5 "FATAL: Cannot prepare test area"
926 exit 1
929 HOME="$TRASH_DIRECTORY"
930 GNUPGHOME="$HOME/gnupg-home-not-used"
931 export HOME GNUPGHOME
933 if test -z "$TEST_NO_CREATE_REPO"
934 then
935 test_create_repo "$TRASH_DIRECTORY"
936 else
937 mkdir -p "$TRASH_DIRECTORY"
939 # Use -P to resolve symlinks in our working directory so that the cwd
940 # in subprocesses like git equals our $PWD (for pathname comparisons).
941 cd -P "$TRASH_DIRECTORY" || exit 1
943 this_test=${0##*/}
944 this_test=${this_test%%-*}
945 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
946 then
947 say_color info >&3 "skipping test $this_test altogether"
948 skip_all="skip all tests in $this_test"
949 test_done
952 # Provide an implementation of the 'yes' utility
953 yes () {
954 if test $# = 0
955 then
957 else
958 y="$*"
962 while test $i -lt 99
964 echo "$y"
965 i=$(($i+1))
966 done
969 # Fix some commands on Windows
970 uname_s=$(uname -s)
971 case $uname_s in
972 *MINGW*)
973 # Windows has its own (incompatible) sort and find
974 sort () {
975 /usr/bin/sort "$@"
977 find () {
978 /usr/bin/find "$@"
980 sum () {
981 md5sum "$@"
983 # git sees Windows-style pwd
984 pwd () {
985 builtin pwd -W
987 # no POSIX permissions
988 # backslashes in pathspec are converted to '/'
989 # exec does not inherit the PID
990 test_set_prereq MINGW
991 test_set_prereq NATIVE_CRLF
992 test_set_prereq SED_STRIPS_CR
993 test_set_prereq GREP_STRIPS_CR
994 GIT_TEST_CMP=mingw_test_cmp
996 *CYGWIN*)
997 test_set_prereq POSIXPERM
998 test_set_prereq EXECKEEPSPID
999 test_set_prereq CYGWIN
1000 test_set_prereq SED_STRIPS_CR
1001 test_set_prereq GREP_STRIPS_CR
1004 test_set_prereq POSIXPERM
1005 test_set_prereq BSLASHPSPEC
1006 test_set_prereq EXECKEEPSPID
1008 esac
1010 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1011 test -z "$NO_PERL" && test_set_prereq PERL
1012 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1013 test -n "$USE_LIBPCRE" && test_set_prereq PCRE
1014 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1016 # Can we rely on git's output in the C locale?
1017 if test -n "$GETTEXT_POISON"
1018 then
1019 GIT_GETTEXT_POISON=YesPlease
1020 export GIT_GETTEXT_POISON
1021 test_set_prereq GETTEXT_POISON
1022 else
1023 test_set_prereq C_LOCALE_OUTPUT
1026 # Use this instead of test_cmp to compare files that contain expected and
1027 # actual output from git commands that can be translated. When running
1028 # under GETTEXT_POISON this pretends that the command produced expected
1029 # results.
1030 test_i18ncmp () {
1031 test -n "$GETTEXT_POISON" || test_cmp "$@"
1034 # Use this instead of "grep expected-string actual" to see if the
1035 # output from a git command that can be translated either contains an
1036 # expected string, or does not contain an unwanted one. When running
1037 # under GETTEXT_POISON this pretends that the command produced expected
1038 # results.
1039 test_i18ngrep () {
1040 if test -n "$GETTEXT_POISON"
1041 then
1042 : # pretend success
1043 elif test "x!" = "x$1"
1044 then
1045 shift
1046 ! grep "$@"
1047 else
1048 grep "$@"
1052 test_lazy_prereq PIPE '
1053 # test whether the filesystem supports FIFOs
1054 case $(uname -s) in
1055 CYGWIN*|MINGW*)
1056 false
1059 rm -f testfifo && mkfifo testfifo
1061 esac
1064 test_lazy_prereq SYMLINKS '
1065 # test whether the filesystem supports symbolic links
1066 ln -s x y && test -h y
1069 test_lazy_prereq FILEMODE '
1070 test "$(git config --bool core.filemode)" = true
1073 test_lazy_prereq CASE_INSENSITIVE_FS '
1074 echo good >CamelCase &&
1075 echo bad >camelcase &&
1076 test "$(cat CamelCase)" != good
1079 test_lazy_prereq UTF8_NFD_TO_NFC '
1080 # check whether FS converts nfd unicode to nfc
1081 auml=$(printf "\303\244")
1082 aumlcdiar=$(printf "\141\314\210")
1083 >"$auml" &&
1084 case "$(echo *)" in
1085 "$aumlcdiar")
1086 true ;;
1088 false ;;
1089 esac
1092 test_lazy_prereq AUTOIDENT '
1093 sane_unset GIT_AUTHOR_NAME &&
1094 sane_unset GIT_AUTHOR_EMAIL &&
1095 git var GIT_AUTHOR_IDENT
1098 test_lazy_prereq EXPENSIVE '
1099 test -n "$GIT_TEST_LONG"
1102 test_lazy_prereq USR_BIN_TIME '
1103 test -x /usr/bin/time
1106 test_lazy_prereq NOT_ROOT '
1107 uid=$(id -u) &&
1108 test "$uid" != 0
1111 test_lazy_prereq JGIT '
1112 type jgit
1115 # SANITY is about "can you correctly predict what the filesystem would
1116 # do by only looking at the permission bits of the files and
1117 # directories?" A typical example of !SANITY is running the test
1118 # suite as root, where a test may expect "chmod -r file && cat file"
1119 # to fail because file is supposed to be unreadable after a successful
1120 # chmod. In an environment (i.e. combination of what filesystem is
1121 # being used and who is running the tests) that lacks SANITY, you may
1122 # be able to delete or create a file when the containing directory
1123 # doesn't have write permissions, or access a file even if the
1124 # containing directory doesn't have read or execute permissions.
1126 test_lazy_prereq SANITY '
1127 mkdir SANETESTD.1 SANETESTD.2 &&
1129 chmod +w SANETESTD.1 SANETESTD.2 &&
1130 >SANETESTD.1/x 2>SANETESTD.2/x &&
1131 chmod -w SANETESTD.1 &&
1132 chmod -r SANETESTD.1/x &&
1133 chmod -rx SANETESTD.2 ||
1134 error "bug in test sript: cannot prepare SANETESTD"
1136 ! test -r SANETESTD.1/x &&
1137 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1138 status=$?
1140 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1141 rm -rf SANETESTD.1 SANETESTD.2 ||
1142 error "bug in test sript: cannot clean SANETESTD"
1143 return $status
1146 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1147 GIT_UNZIP=${GIT_UNZIP:-unzip}
1148 test_lazy_prereq UNZIP '
1149 "$GIT_UNZIP" -v
1150 test $? -ne 127
1153 run_with_limited_cmdline () {
1154 (ulimit -s 128 && "$@")
1157 test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
1159 build_option () {
1160 git version --build-options |
1161 sed -ne "s/^$1: //p"
1164 test_lazy_prereq LONG_IS_64BIT '
1165 test 8 -le "$(build_option sizeof-long)"